Index: trunk/client/modules/Elezioni/grafici/jpgraph_pie.php
===================================================================
--- trunk/client/modules/Elezioni/grafici/jpgraph_pie.php	(revision 264)
+++ trunk/client/modules/Elezioni/grafici/jpgraph_pie.php	(revision 265)
@@ -947,71 +965,75 @@
     function StrokeLabel($label,$img,$xc,$yc,$a,$r) {
 
-	// Default value
-	if( $this->ilabelposadj === 'auto' )
-	    $this->ilabelposadj = 0.65;
-
-	// We position the values diferently depending on if they are inside
-	// or outside the pie
-	if( $this->ilabelposadj < 1.0 ) {
-
-	    $this->value->SetAlign('center','center');
-	    $this->value->margin = 0;
-	    
-	    $xt=round($this->ilabelposadj*$r*cos($a)+$xc);
-	    $yt=round($yc-$this->ilabelposadj*$r*sin($a));
-	    
-	    $this->value->Stroke($img,$label,$xt,$yt);
-	}
-	else {
-
-	    $this->value->halign = "left";
-	    $this->value->valign = "top";
-	    $this->value->margin = 0;
-	    	    
-	    // Position the axis title. 
-	    // dx, dy is the offset from the top left corner of the bounding box that sorrounds the text
-	    // that intersects with the extension of the corresponding axis. The code looks a little
-	    // bit messy but this is really the only way of having a reasonable position of the
-	    // axis titles.
-	    $this->value->ApplyFont($img);
-	    $h=$img->GetTextHeight($label);
-	    // For numeric values the format of the display value
-	    // must be taken into account
-	    if( is_numeric($label) ) {
-		if( $label > 0 )
-		    $w=$img->GetTextWidth(sprintf($this->value->format,$label));
-		else
-		    $w=$img->GetTextWidth(sprintf($this->value->negformat,$label));
-	    }
-	    else
-		$w=$img->GetTextWidth($label);
-
-	    if( $this->ilabelposadj > 1.0 && $this->ilabelposadj < 5.0) {
-		$r *= $this->ilabelposadj;
-	    }
-	    
-	    $r += $img->GetFontHeight()/1.5;
-
-	    $xt=round($r*cos($a)+$xc);
-	    $yt=round($yc-$r*sin($a));
-
-	    // Normalize angle
-	    while( $a < 0 ) $a += 2*M_PI;
-	    while( $a > 2*M_PI ) $a -= 2*M_PI;
-
-	    if( $a>=7*M_PI/4 || $a <= M_PI/4 ) $dx=0;
-	    if( $a>=M_PI/4 && $a <= 3*M_PI/4 ) $dx=($a-M_PI/4)*2/M_PI; 
-	    if( $a>=3*M_PI/4 && $a <= 5*M_PI/4 ) $dx=1;
-	    if( $a>=5*M_PI/4 && $a <= 7*M_PI/4 ) $dx=(1-($a-M_PI*5/4)*2/M_PI);
-	    
-	    if( $a>=7*M_PI/4 ) $dy=(($a-M_PI)-3*M_PI/4)*2/M_PI;
-	    if( $a<=M_PI/4 ) $dy=(1-$a*2/M_PI);
-	    if( $a>=M_PI/4 && $a <= 3*M_PI/4 ) $dy=1;
-	    if( $a>=3*M_PI/4 && $a <= 5*M_PI/4 ) $dy=(1-($a-3*M_PI/4)*2/M_PI);
-	    if( $a>=5*M_PI/4 && $a <= 7*M_PI/4 ) $dy=0;
-	    
-	    $this->value->Stroke($img,$label,$xt-$dx*$w,$yt-$dy*$h);
-	}
-    }	
+        // Default value
+        if( $this->ilabelposadj === 'auto' )
+        $this->ilabelposadj = 0.65;
+
+        // We position the values diferently depending on if they are inside
+        // or outside the pie
+        if( $this->ilabelposadj < 1.0 ) {
+
+            $this->value->SetAlign('center','center');
+            $this->value->margin = 0;
+
+            $xt=round($this->ilabelposadj*$r*cos($a)+$xc);
+            $yt=round($yc-$this->ilabelposadj*$r*sin($a));
+
+            $this->value->Stroke($img,$label,$xt,$yt);
+        }
+        else {
+
+            $this->value->halign = "left";
+            $this->value->valign = "top";
+            $this->value->margin = 0;
+
+            // Position the axis title.
+            // dx, dy is the offset from the top left corner of the bounding box that sorrounds the text
+            // that intersects with the extension of the corresponding axis. The code looks a little
+            // bit messy but this is really the only way of having a reasonable position of the
+            // axis titles.
+            $this->value->ApplyFont($img);
+            $h=$img->GetTextHeight($label);
+            // For numeric values the format of the display value
+            // must be taken into account
+            if( is_numeric($label) ) {
+                if( $label > 0 )
+                $w=$img->GetTextWidth(sprintf($this->value->format,$label));
+                else
+                $w=$img->GetTextWidth(sprintf($this->value->negformat,$label));
+            }
+            else
+            $w=$img->GetTextWidth($label);
+
+            if( $this->ilabelposadj > 1.0 && $this->ilabelposadj < 5.0) {
+                $r *= $this->ilabelposadj;
+            }
+
+            $r += $img->GetFontHeight()/1.5;
+
+            $xt=round($r*cos($a)+$xc);
+            $yt=round($yc-$r*sin($a));
+
+            // Normalize angle
+            while( $a < 0 ) $a += 2*M_PI;
+            while( $a > 2*M_PI ) $a -= 2*M_PI;
+
+            if( $a>=7*M_PI/4 || $a <= M_PI/4 ) $dx=0;
+            if( $a>=M_PI/4 && $a <= 3*M_PI/4 ) $dx=($a-M_PI/4)*2/M_PI;
+            if( $a>=3*M_PI/4 && $a <= 5*M_PI/4 ) $dx=1;
+            if( $a>=5*M_PI/4 && $a <= 7*M_PI/4 ) $dx=(1-($a-M_PI*5/4)*2/M_PI);
+
+            if( $a>=7*M_PI/4 ) $dy=(($a-M_PI)-3*M_PI/4)*2/M_PI;
+            if( $a<=M_PI/4 ) $dy=(1-$a*2/M_PI);
+            if( $a>=M_PI/4 && $a <= 3*M_PI/4 ) $dy=1;
+            if( $a>=3*M_PI/4 && $a <= 5*M_PI/4 ) $dy=(1-($a-3*M_PI/4)*2/M_PI);
+            if( $a>=5*M_PI/4 && $a <= 7*M_PI/4 ) $dy=0;
+
+            $this->value->Stroke($img,$label,$xt-$dx*$w,$yt-$dy*$h);
+        }
+    }
+
+    function UsePlotThemeColors($flag = true) {
+        $this->use_plot_theme_colors = $flag;
+    }
 } // Class
 
@@ -1019,126 +1041,126 @@
 //===================================================
 // CLASS PiePlotC
-// Description: Same as a normal pie plot but with a 
+// Description: Same as a normal pie plot but with a
 // filled circle in the center
 //===================================================
 class PiePlotC extends PiePlot {
-    private $imidsize=0.5;		// Fraction of total width
+    private $imidsize=0.5;  // Fraction of total width
     private $imidcolor='white';
     public $midtitle='';
     private $middlecsimtarget='',$middlecsimwintarget='',$middlecsimalt='';
 
-    function PiePlotC($data,$aCenterTitle='') {
-	parent::PiePlot($data);
-	$this->midtitle = new Text();
-	$this->midtitle->ParagraphAlign('center');
+    function __construct($data,$aCenterTitle='') {
+        parent::__construct($data);
+        $this->midtitle = new Text();
+        $this->midtitle->ParagraphAlign('center');
     }
 
     function SetMid($aTitle,$aColor='white',$aSize=0.5) {
-	$this->midtitle->Set($aTitle);
-
-	$this->imidsize = $aSize ; 
-	$this->imidcolor = $aColor ; 
+        $this->midtitle->Set($aTitle);
+
+        $this->imidsize = $aSize ;
+        $this->imidcolor = $aColor ;
     }
 
     function SetMidTitle($aTitle) {
-	$this->midtitle->Set($aTitle);
+        $this->midtitle->Set($aTitle);
     }
 
     function SetMidSize($aSize) {
-	$this->imidsize = $aSize ; 
+        $this->imidsize = $aSize ;
     }
 
     function SetMidColor($aColor) {
-	$this->imidcolor = $aColor ; 
+        $this->imidcolor = $aColor ;
     }
 
     function SetMidCSIM($aTarget,$aAlt='',$aWinTarget='') {
-	$this->middlecsimtarget = $aTarget;
-	$this->middlecsimwintarget = $aWinTarget;
-	$this->middlecsimalt = $aAlt;
-    }
-
-    function AddSliceToCSIM($i,$xc,$yc,$radius,$sa,$ea) {  
+        $this->middlecsimtarget = $aTarget;
+        $this->middlecsimwintarget = $aWinTarget;
+        $this->middlecsimalt = $aAlt;
+    }
+
+    function AddSliceToCSIM($i,$xc,$yc,$radius,$sa,$ea) {
         //Slice number, ellipse centre (x,y), radius, start angle, end angle
-	while( $sa > 2*M_PI ) $sa = $sa - 2*M_PI;
-	while( $ea > 2*M_PI ) $ea = $ea - 2*M_PI;
-
-	$sa = 2*M_PI - $sa;
-	$ea = 2*M_PI - $ea;
-
-	// Special case when we have only one slice since then both start and end
-	// angle will be == 0
-	if( abs($sa - $ea) < 0.0001 ) {
-	    $sa=2*M_PI; $ea=0;
-	}
-
-	// Add inner circle first point
-	$xp = floor(($this->imidsize*$radius*cos($ea))+$xc);
-	$yp = floor($yc-($this->imidsize*$radius*sin($ea)));
-	$coords = "$xp, $yp";
-	
-	//add coordinates every 0.25 radians
-	$a=$ea+0.25;
-
-	// If we cross the 360-limit with a slice we need to handle
-	// the fact that end angle is smaller than start
-	if( $sa < $ea ) {
-	    while ($a <= 2*M_PI) {
-		$xp = floor($radius*cos($a)+$xc);
-		$yp = floor($yc-$radius*sin($a));
-		$coords.= ", $xp, $yp";
-		$a += 0.25;
-	    }
-	    $a -= 2*M_PI;
-	}
-
-	while ($a < $sa) {
-	    $xp = floor(($this->imidsize*$radius*cos($a)+$xc));
-	    $yp = floor($yc-($this->imidsize*$radius*sin($a)));
-	    $coords.= ", $xp, $yp";
-	    $a += 0.25;
-	}
-
-	// Make sure we end at the last point
-	$xp = floor(($this->imidsize*$radius*cos($sa)+$xc));
-	$yp = floor($yc-($this->imidsize*$radius*sin($sa)));
-	$coords.= ", $xp, $yp";
-
-	// Straight line to outer circle
-	$xp = floor($radius*cos($sa)+$xc);
-	$yp = floor($yc-$radius*sin($sa));
-	$coords.= ", $xp, $yp";	
-
-	//add coordinates every 0.25 radians
-	$a=$sa - 0.25;
-	while ($a > $ea) {
-	    $xp = floor($radius*cos($a)+$xc);
-	    $yp = floor($yc-$radius*sin($a));
-	    $coords.= ", $xp, $yp";
-	    $a -= 0.25;
-	}
-		
-	//Add the last point on the arc
-	$xp = floor($radius*cos($ea)+$xc);
-	$yp = floor($yc-$radius*sin($ea));
-	$coords.= ", $xp, $yp";
-
-	// Close the arc
-	$xp = floor(($this->imidsize*$radius*cos($ea))+$xc);
-	$yp = floor($yc-($this->imidsize*$radius*sin($ea)));
-	$coords .= ", $xp, $yp";
-
-	if( !empty($this->csimtargets[$i]) ) {
-	    $this->csimareas .= "<area shape=\"poly\" coords=\"$coords\" href=\"".
-		$this->csimtargets[$i]."\"";
-	    if( !empty($this->csimwintargets[$i]) ) {
-		$this->csimareas .= " target=\"".$this->csimwintargets[$i]."\" ";
-	    }
-	    if( !empty($this->csimalts[$i]) ) {
-		$tmp=sprintf($this->csimalts[$i],$this->data[$i]);
-		$this->csimareas .= " title=\"$tmp\"  alt=\"$tmp\" ";
-	    }
-	    $this->csimareas .= " />\n";
-	}
+        while( $sa > 2*M_PI ) $sa = $sa - 2*M_PI;
+        while( $ea > 2*M_PI ) $ea = $ea - 2*M_PI;
+
+        $sa = 2*M_PI - $sa;
+        $ea = 2*M_PI - $ea;
+
+        // Special case when we have only one slice since then both start and end
+        // angle will be == 0
+        if( abs($sa - $ea) < 0.0001 ) {
+            $sa=2*M_PI; $ea=0;
+        }
+
+        // Add inner circle first point
+        $xp = floor(($this->imidsize*$radius*cos($ea))+$xc);
+        $yp = floor($yc-($this->imidsize*$radius*sin($ea)));
+        $coords = "$xp, $yp";
+
+        //add coordinates every 0.25 radians
+        $a=$ea+0.25;
+
+        // If we cross the 360-limit with a slice we need to handle
+        // the fact that end angle is smaller than start
+        if( $sa < $ea ) {
+            while ($a <= 2*M_PI) {
+                $xp = floor($radius*cos($a)+$xc);
+                $yp = floor($yc-$radius*sin($a));
+                $coords.= ", $xp, $yp";
+                $a += 0.25;
+            }
+            $a -= 2*M_PI;
+        }
+
+        while ($a < $sa) {
+            $xp = floor(($this->imidsize*$radius*cos($a)+$xc));
+            $yp = floor($yc-($this->imidsize*$radius*sin($a)));
+            $coords.= ", $xp, $yp";
+            $a += 0.25;
+        }
+
+        // Make sure we end at the last point
+        $xp = floor(($this->imidsize*$radius*cos($sa)+$xc));
+        $yp = floor($yc-($this->imidsize*$radius*sin($sa)));
+        $coords.= ", $xp, $yp";
+
+        // Straight line to outer circle
+        $xp = floor($radius*cos($sa)+$xc);
+        $yp = floor($yc-$radius*sin($sa));
+        $coords.= ", $xp, $yp";
+
+        //add coordinates every 0.25 radians
+        $a=$sa - 0.25;
+        while ($a > $ea) {
+            $xp = floor($radius*cos($a)+$xc);
+            $yp = floor($yc-$radius*sin($a));
+            $coords.= ", $xp, $yp";
+            $a -= 0.25;
+        }
+
+        //Add the last point on the arc
+        $xp = floor($radius*cos($ea)+$xc);
+        $yp = floor($yc-$radius*sin($ea));
+        $coords.= ", $xp, $yp";
+
+        // Close the arc
+        $xp = floor(($this->imidsize*$radius*cos($ea))+$xc);
+        $yp = floor($yc-($this->imidsize*$radius*sin($ea)));
+        $coords .= ", $xp, $yp";
+
+        if( !empty($this->csimtargets[$i]) ) {
+            $this->csimareas .= "<area shape=\"poly\" coords=\"$coords\" href=\"".
+            $this->csimtargets[$i]."\"";
+            if( !empty($this->csimwintargets[$i]) ) {
+                $this->csimareas .= " target=\"".$this->csimwintargets[$i]."\" ";
+            }
+            if( !empty($this->csimalts[$i]) ) {
+                $tmp=sprintf($this->csimalts[$i],$this->data[$i]);
+                $this->csimareas .= " title=\"$tmp\"  alt=\"$tmp\" ";
+            }
+            $this->csimareas .= " />\n";
+        }
     }
 
@@ -1146,65 +1168,65 @@
     function Stroke($img,$aaoption=0) {
 
-	// Stroke the pie but don't stroke values
-	$tmp =  $this->value->show;
-	$this->value->show = false;
-	parent::Stroke($img,$aaoption);
-	$this->value->show = $tmp;
-
- 	$xc = round($this->posx*$img->width);
-	$yc = round($this->posy*$img->height);
-
-	$radius = floor($this->radius * min($img->width,$img->height)) ;
-
-
-	if( $this->imidsize > 0 && $aaoption !== 2 ) {
-
-	    if( $this->ishadowcolor != "" ) {
-		$img->SetColor($this->ishadowcolor);
-		$img->FilledCircle($xc+$this->ishadowdrop,$yc+$this->ishadowdrop,
-				   round($radius*$this->imidsize));
-	    }
-
-	    $img->SetColor($this->imidcolor);
-	    $img->FilledCircle($xc,$yc,round($radius*$this->imidsize));
-
-	    if(  $this->pie_border && $aaoption === 0 ) {
-		$img->SetColor($this->color);
-		$img->Circle($xc,$yc,round($radius*$this->imidsize));
-	    }
-
-	    if( !empty($this->middlecsimtarget) )
-		$this->AddMiddleCSIM($xc,$yc,round($radius*$this->imidsize));
-
-	}
-
-	if( $this->value->show && $aaoption !== 1) {
-	    $this->StrokeAllLabels($img,$xc,$yc,$radius);
-	    $this->midtitle->SetPos($xc,$yc,'center','center');
-	    $this->midtitle->Stroke($img);
-	}
+        // Stroke the pie but don't stroke values
+        $tmp =  $this->value->show;
+        $this->value->show = false;
+        parent::Stroke($img,$aaoption);
+        $this->value->show = $tmp;
+
+        $xc = round($this->posx*$img->width);
+        $yc = round($this->posy*$img->height);
+
+        $radius = floor($this->radius * min($img->width,$img->height)) ;
+
+
+        if( $this->imidsize > 0 && $aaoption !== 2 ) {
+
+            if( $this->ishadowcolor != "" ) {
+                $img->SetColor($this->ishadowcolor);
+                $img->FilledCircle($xc+$this->ishadowdrop,$yc+$this->ishadowdrop,
+                round($radius*$this->imidsize));
+            }
+
+            $img->SetColor($this->imidcolor);
+            $img->FilledCircle($xc,$yc,round($radius*$this->imidsize));
+
+            if(  $this->pie_border && $aaoption === 0 ) {
+                $img->SetColor($this->color);
+                $img->Circle($xc,$yc,round($radius*$this->imidsize));
+            }
+
+            if( !empty($this->middlecsimtarget) )
+            $this->AddMiddleCSIM($xc,$yc,round($radius*$this->imidsize));
+
+        }
+
+        if( $this->value->show && $aaoption !== 1) {
+            $this->StrokeAllLabels($img,$xc,$yc,$radius);
+            $this->midtitle->SetPos($xc,$yc,'center','center');
+            $this->midtitle->Stroke($img);
+        }
 
     }
 
     function AddMiddleCSIM($xc,$yc,$r) {
-	$xc=round($xc);$yc=round($yc);$r=round($r);
-	$this->csimareas .= "<area shape=\"circle\" coords=\"$xc,$yc,$r\" href=\"".
-	    $this->middlecsimtarget."\"";
-	if( !empty($this->middlecsimwintarget) ) {
-	    $this->csimareas .= " target=\"".$this->middlecsimwintarget."\"";
-	}
-	if( !empty($this->middlecsimalt) ) {
-	    $tmp = $this->middlecsimalt;
-	    $this->csimareas .= " title=\"$tmp\" alt=\"$tmp\" ";
-	}
-	$this->csimareas .= " />\n";
+        $xc=round($xc);$yc=round($yc);$r=round($r);
+        $this->csimareas .= "<area shape=\"circle\" coords=\"$xc,$yc,$r\" href=\"".
+        $this->middlecsimtarget."\"";
+        if( !empty($this->middlecsimwintarget) ) {
+            $this->csimareas .= " target=\"".$this->middlecsimwintarget."\"";
+        }
+        if( !empty($this->middlecsimalt) ) {
+            $tmp = $this->middlecsimalt;
+            $this->csimareas .= " title=\"$tmp\" alt=\"$tmp\" ";
+        }
+        $this->csimareas .= " />\n";
     }
 
     function StrokeLabel($label,$img,$xc,$yc,$a,$r) {
 
-	if( $this->ilabelposadj === 'auto' )
-	    $this->ilabelposadj = (1-$this->imidsize)/2+$this->imidsize;
-
-	parent::StrokeLabel($label,$img,$xc,$yc,$a,$r);
+        if( $this->ilabelposadj === 'auto' )
+        $this->ilabelposadj = (1-$this->imidsize)/2+$this->imidsize;
+
+        parent::StrokeLabel($label,$img,$xc,$yc,$a,$r);
 
     }
